# lee_perfil_3.py
# este programa, abre un archivo externo generado por otros medios
# Las lineas que empiezan con / son desechados pudiendose usar como linea de comentario en el archivo
# donde la informacion contenida representa para cada punto de la cuerda, el espesor relativo
# de un perfil NACA
# posteriormente se almacenan dichos datos en listas y se los grafica, permitiendo el movimiento
# en x e y mediante barras de control (objetos de Tkinter
# 
import math as m
import tkinter as Tkinter # importa la libreria Tkinter
w_max=400.0     # ancho de ventana
h_max=300.0     # alto de ventana
x=0.            # variable global de desplazamiento en x e y
y=0.
g=0.
perfil="NACA2412_perfil.txt"    #define nombre de archivo que contiene los datos
cu=[]           # lista vacia en la que quedaran las coordenadas de la cuerad
top=[]          # lista donde quedaran las coordenadas del espesor respecto de la cuerda
cuerda=100.     # valor arbitrario de cuerda, ya que los valores de tabla est'an adimensionalizados

def carga(nombre):
    # rutina que carga  en las listas cu y top los valores que vienen en el archivo
    
    f=open(nombre,'r')      # el archivo debe estar en la misma carpeta que el programa
    for linea in f.readlines():     #este for desgrana una a una la lista de lineas que lee readlines
        if not linea.find("/")==0:  # me fijo si empieza con /
            dumm=linea.split("     ")                      # separo la linea en una lista de nombre dumm buscando las ocurrencias de "  "
            cu.append(float(dumm[0])*cuerda+100)            # al ser cu y top definidas en el cuerpo principalson tomadas como globales
            top.append(float(dumm[1])*cuerda+100)
    print (len(cu))
    f.close()                                   # cierro el archivo
    return 
    
def boton():
    # rutina que recupera el nombre del archivo, lo carga
    # y llama a rutina trasla que a su vez llama a rutina dibuja
    del cu[:]
    del top[:]
    carga(e1.get()+".txt")
    trasla(x,y,g)
    return

def regla_tx(x1):
    # rutina que toma el valor del deslizante y lo trasnforma en un numero representano el desplazamiento x
    #global x,y
    x=float(x1)
    trasla(x,y,g)     #   llama a la rutina de traslacion
    return

def regla_ty(y1):
    # rutina que toma el valor del deslizante y lo trasnforma en un numero representano el desplazamiento y
    #global x,y
    y=float(y1)
    trasla(x,y,g)     #   llama a la rutina de traslacion
    return
    
def regla_g(g1):
    # rutina que toma el valor del deslizante y lo trasnforma en un numero representano el desplazamiento y
    #global x,y
    g=float(g1)
    trasla(x,y,g)     #   llama a la rutina de traslacion
    return

def trasla(desp_x,desp_y,alfa):
    # rutina que toma  los valores de cu y top y par a par les aplica la matriz 
    # de trasnformacion que en este caso es de traslacion
    print (len(cu),"traspa")
    #alfa=0.1
    m_t=[[m.cos(alfa),m.sin(alfa),0.],[-m.sin(alfa),m.cos(alfa),0.],[desp_x,desp_y,1.]]      # matriz de traslacion
    x_t=[]
    y_t=[]
    dum=[0.,0.,1.]
    for i in range(len(cu)-1):                      # barre todos los pares 
        x_t.append(0.)                              # genero dos listas auxiliares para trabajar
        y_t.append(0.)
        
        dum[0]=cu[i]                                # dum es otra lista auxiliar para poder hacer la multiplicacion
        dum[1]=h_max-top[i]                         # aprovecho en este logar para dar vuelta el sistema de referencia del canvas
        dum[2]=1.0
        for j in range(3):                          # multiplico la lista dum por la matriz m_t
            tacho=0.
            for k in range(3):
                tacho=tacho+dum[k]*m_t[k][j]
            dum[j]=tacho                            # devuelve en dum la lista trasnformada
        
        x_t[i]=dum[0]               # traspaso a laslistas de trabajo                               
        y_t[i]=dum[1]
    dibuja(x_t,y_t)                 # llamo a la rutina de dibujo con las listas de trabajo
    return  


def dibuja(x,y):
    # esta rutina borra el canvas
    canvas.delete(Tkinter.ALL)
    for i in range(len(x)-1):                       #iterativamente trazo lineas de un punto al siguiente
        canvas.create_line(x[i],y[i], x[i+1],y[i+1])
    return


#########################
#       cuerpo principal
#########################



#   Invoco el creador de Tk, que me devuelve una ventana a la que nombro root
root = Tkinter.Tk()
#   a ese objeto le modifico la propiedad titulo
root.title("PERFIL")
#   Invoco el creador del objeto canvas dentro del objeto root y lo llamo canvas
canvas = Tkinter.Canvas(root,width=w_max, height=h_max,bg='white')
#   Hubico el  objeto canvas dentro del onbejto ventana
#   ocupando las dos primeras filas y columnas
canvas.grid(column=0, row=0,columnspan=2,rowspan=3) 
#   creo dentro del objeto root una etiqueta y lapongo en la fila 0 columna 4
lab1=Tkinter.Label(root,text="XMOVE")
lab1.grid(row=0,column=4,sticky=Tkinter.E)
#   creo dentro del objeto root una barra deslizante
#   esta barra cuando es movida, llama a la rutina definida en command
#   las propiedade de la barra de los valores por los que se desliza y su resolucion se definen aqui.
#   se hubica la barra en forma horizontal en la fila 0 columna 5
root_x=Tkinter.Scale(root,orient="horizontal",command=regla_tx,from_=-100.0,to=100.0,resolution=10.0)
root_x.grid(row=0,column=5)

#   idem par ala barra de movimiento vertical
lab2=Tkinter.Label(root,text="YMOVE")
lab2.grid(row=1,column=6,sticky=Tkinter.N)
root_y=Tkinter.Scale(root,orient="vertical",command=regla_ty,from_=-100.0,to=100.0,resolution=10.0)
root_y.grid(row=0,column=6)

#   idem par ala barra de movimiento vertical
lab3=Tkinter.Label(root,text="ROT")
lab3.grid(row=2,column=4,sticky=Tkinter.E)
root_g=Tkinter.Scale(root,orient="horizontal",command=regla_g,from_=-1.0,to=1.0,resolution=0.10)
root_g.grid(row=2,column=5)

#  creoLabel con el texto
Tkinter.Label(root, text="Perfil").grid(row=1,column=4)

# creo control textbox
e1 = Tkinter.Entry(root,width=20)
e1.grid(row=1, column=5)

# creo control boton para mandar a cargar archivo
b = Tkinter.Button(root, text ="Ok", command = boton)
b.grid(row=2, column=6)

# llamo la rutina para leer el archivo

carga(perfil)

#   se llama a la rutina trasla con valores iniciales por primera vez


trasla(x,y,g)

#   se entra en un loop infinito en el cual el objeto root espera las acciones que sobre el se realicen
#   mediante los objetos que lo componen, y cad uno de ellos las despacha a la rutina adecuada.
root.mainloop()

